Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 443)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 608)
@@ -1942,355 +2004,69 @@
 }
 
-#if LGE_SAO_MIGRATION_D0091
+
 Void TDecSbac::parseSaoMaxUvlc ( UInt& val, UInt maxSymbol )
 {
-    if (maxSymbol == 0)
-    {
-        val = 0;
-        return;
-    }
-
-    UInt code;
-    Int  i;
+  if (maxSymbol == 0)
+  {
+    val = 0;
+    return;
+  }
+
+  UInt code;
+  Int  i;
+  m_pcTDecBinIf->decodeBinEP( code );
+  if ( code == 0 )
+  {
+    val = 0;
+    return;
+  }
+
+  i=1;
+  while (1)
+  {
     m_pcTDecBinIf->decodeBinEP( code );
     if ( code == 0 )
     {
-        val = 0;
-        return;
-    }
-
-    i=1;
-    while (1)
-    {
-        m_pcTDecBinIf->decodeBinEP( code );
-        if ( code == 0 )
-        {
-            break;
-        }
-        i++;
-        if (i == maxSymbol)
-        {
-            break;
-        }
-    }   
-
-    val = i;
-}
-
+      break;
+    }
+    i++;
+    if (i == maxSymbol) 
+    {
+      break;
+    }
+  }
+
+  val = i;
+}
 Void TDecSbac::parseSaoUflc (UInt uiLength, UInt&  riVal)
 {
-    m_pcTDecBinIf->decodeBinsEP ( riVal, uiLength );
-}
-
+  m_pcTDecBinIf->decodeBinsEP ( riVal, uiLength );
+}
 Void TDecSbac::parseSaoMerge (UInt&  ruiVal)
 {
-    UInt uiCode;
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeSCModel.get( 0, 0, 0 ) );
-    ruiVal = (Int)uiCode;
-}
-
+  UInt uiCode;
+  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeSCModel.get( 0, 0, 0 ) );
+  ruiVal = (Int)uiCode;
+}
 Void TDecSbac::parseSaoTypeIdx (UInt&  ruiVal)
 {
-    UInt uiCode;
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
-    if (uiCode == 0) 
-    {
-        ruiVal = 0;
+  UInt uiCode;
+  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
+  if (uiCode == 0) 
+  {
+    ruiVal = 0;
+  }
+  else
+  {
+    m_pcTDecBinIf->decodeBinEP( uiCode ); 
+    if (uiCode == 0)
+    {
+      ruiVal = 5;
     }
     else
     {
-        m_pcTDecBinIf->decodeBinEP( uiCode ); 
-        if (uiCode == 0)
-        {
-            ruiVal = 5;
-        }
-        else
-        {
-            ruiVal = 1;
-        }
-    }
-}
-
-inline Void copySaoOneLcuParam(SaoLcuParam* psDst,  SaoLcuParam* psSrc)
-{
-    Int i;
-    psDst->partIdx = psSrc->partIdx;
-    psDst->typeIdx = psSrc->typeIdx;
-    if (psDst->typeIdx != -1)
-    {
-        psDst->subTypeIdx = psSrc->subTypeIdx ;
-        psDst->length  = psSrc->length;
-        for (i=0;i<psDst->length;i++)
-        {
-            psDst->offset[i] = psSrc->offset[i];
-        }
-    }
-    else
-    {
-        psDst->length  = 0;
-        for (i=0;i<SAO_BO_LEN;i++)
-        {
-            psDst->offset[i] = 0;
-        }
-    }
-}
-
-Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam, UInt compIdx)
-{
-    UInt uiSymbol;
-    static Int iTypeLength[MAX_NUM_SAO_TYPE] =
-    {
-        SAO_EO_LEN,
-        SAO_EO_LEN,
-        SAO_EO_LEN,
-        SAO_EO_LEN,
-        SAO_BO_LEN
-    }; 
-
-    if (compIdx==2)
-    {
-        uiSymbol = (UInt)( psSaoLcuParam->typeIdx + 1);
-    }
-    else
-    {
-        parseSaoTypeIdx(uiSymbol);
-    }
-    psSaoLcuParam->typeIdx = (Int)uiSymbol - 1;
-
-    if (uiSymbol)
-    {
-        psSaoLcuParam->length = iTypeLength[psSaoLcuParam->typeIdx];
-#if FULL_NBIT
-        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + (g_uiBitDepth-8)-5),5) );
-#else
-        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + g_uiBitIncrement-5),5) );
-#endif
-
-        if( psSaoLcuParam->typeIdx == SAO_BO )
-        {
-            for(Int i=0; i< psSaoLcuParam->length; i++)
-            {
-                parseSaoMaxUvlc(uiSymbol, offsetTh -1 );
-                psSaoLcuParam->offset[i] = uiSymbol;
-            }   
-            for(Int i=0; i< psSaoLcuParam->length; i++)
-            {
-                if (psSaoLcuParam->offset[i] != 0)
-                {
-                    m_pcTDecBinIf->decodeBinEP ( uiSymbol);
-                    if (uiSymbol)
-                    {
-                        psSaoLcuParam->offset[i] = -psSaoLcuParam->offset[i] ;
-                    }
-                }
-            }
-            parseSaoUflc(5, uiSymbol );
-            psSaoLcuParam->subTypeIdx = uiSymbol;
-        }
-        else if( psSaoLcuParam->typeIdx < 4 )
-        {
-            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[0] = uiSymbol;   
-            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[1] = uiSymbol;
-            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[2] = -(Int)uiSymbol;
-            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[3] = -(Int)uiSymbol;
-            if (compIdx != 2)
-            {
-                parseSaoUflc(2, uiSymbol );
-                psSaoLcuParam->subTypeIdx = uiSymbol;
-                psSaoLcuParam->typeIdx += psSaoLcuParam->subTypeIdx;
-            }
-        }
-    }
-    else
-    {
-        psSaoLcuParam->length = 0;
-    }
-}
-
-Void TDecSbac::parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp)
-{
-    Int iAddr = pcCU->getAddr();
-    UInt uiSymbol;
-
-    for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
-    {
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag    = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag  = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx     = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx        =-1;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[0]      = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[1]      = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[2]      = 0;
-        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[3]      = 0;
-    }
-    if (pSaoParam->bSaoFlag[0] || pSaoParam->bSaoFlag[1] )
-    {
-        if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
-        {
-            parseSaoMerge(uiSymbol); 
-            pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag = (Bool)uiSymbol;  
-        }
-        if (pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag==0)
-        {
-            if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
-            {
-                parseSaoMerge(uiSymbol);
-                pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag = (Bool)uiSymbol;
-            }
-        }
-    }
-
-    for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
-    {
-        if ((iCompIdx == 0  && pSaoParam->bSaoFlag[0]) || (iCompIdx > 0  && pSaoParam->bSaoFlag[1]) )
-        {
-            if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
-            {
-                pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag;
-            }
-            else
-            {
-                pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = 0;
-            }
-
-            if (pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag==0)
-            {
-                if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
-                {
-                    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag;
-                }
-                else
-                {
-                    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = 0;
-                }
-    
-                if (!pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag)
-                {
-                    pSaoParam->saoLcuParam[2][iAddr].typeIdx = pSaoParam->saoLcuParam[1][iAddr].typeIdx;
-                    parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]), iCompIdx);
-                }
-                else
-                {
-                    copySaoOneLcuParam(&pSaoParam->saoLcuParam[iCompIdx][iAddr], &pSaoParam->saoLcuParam[iCompIdx][iAddr-pSaoParam->numCuInWidth]);
-                }
-            }
-            else
-            {
-                copySaoOneLcuParam(&pSaoParam->saoLcuParam[iCompIdx][iAddr],  &pSaoParam->saoLcuParam[iCompIdx][iAddr-1]);
-            }
-        }
-        else
-        {
-            pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx    = -1;
-            pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx = 0;
-        }
-    }
-}
-#else
-Void TDecSbac::parseSaoUvlc (UInt& ruiVal)
-{
-  UInt uiCode;
-  Int  i;
-
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoUvlcSCModel.get( 0, 0, 0 ) );
-  if ( uiCode == 0 )
-  {
-    ruiVal = 0;
-    return;
-  }
-
-  i=1;
-  while (1)
-  {
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoUvlcSCModel.get( 0, 0, 1 ) );
-    if ( uiCode == 0 ) break;
-    i++;
-  }
-
-  ruiVal = i;
-}
-
-Void TDecSbac::parseSaoSvlc (Int&  riVal)
-{
-  UInt uiCode;
-  Int  iSign;
-  Int  i;
-
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoSvlcSCModel.get( 0, 0, 0 ) );
-
-  if ( uiCode == 0 )
-  {
-    riVal = 0;
-    return;
-  }
-
-  // read sign
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoSvlcSCModel.get( 0, 0, 1 ) );
-
-  if ( uiCode == 0 )
-  {
-    iSign =  1;
-  }
-  else
-  {
-    iSign = -1;
-  }
-
-  // read magnitude
-  i=1;
-  while (1)
-  {
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoSvlcSCModel.get( 0, 0, 2 ) );
-    if ( uiCode == 0 ) break;
-    i++;
-  }
-
-  riVal = i*iSign;
-}
-
-Void TDecSbac::parseSaoUflc (UInt&  riVal)
-{
-  UInt uiSymbol;
-  riVal = 0;
-  for (Int i=0;i<5;i++)
-  {
-    m_pcTDecBinIf->decodeBinEP ( uiSymbol );
-    if (uiSymbol)
-    {
-      riVal |= (1<<i);
-    }
-  }
-}
-Void TDecSbac::parseSaoMergeLeft (UInt&  ruiVal, UInt uiCompIdx)
-{
-  UInt uiCode;
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeLeftSCModel.get( 0, 0, uiCompIdx ) );
-  ruiVal = (Int)uiCode;
-}
-
-Void TDecSbac::parseSaoMergeUp (UInt&  ruiVal)
-{
-  UInt uiCode;
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeUpSCModel.get( 0, 0, 0 ) );
-  ruiVal = (Int)uiCode;
-}
-Void TDecSbac::parseSaoTypeIdx (UInt&  ruiVal)
-{
-  UInt uiCode;
-  Int  i;
-  m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
-  if ( uiCode == 0 )
-  {
-    ruiVal = 0;
-    return;
-  }
-  i=1;
-  while (1)
-  {
-    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 1 ) );
-    if ( uiCode == 0 ) break;
-    i++;
-  }
-  ruiVal = i;
+      ruiVal = 1;
+    }
+  }
 }
 
@@ -2302,12 +2078,5 @@
   if (psDst->typeIdx != -1)
   {
-    if (psDst->typeIdx == SAO_BO)
-    {
-      psDst->bandPosition = psSrc->bandPosition ;
-    }
-    else
-    {
-      psDst->bandPosition = 0;
-    }
+    psDst->subTypeIdx = psSrc->subTypeIdx ;
     psDst->length  = psSrc->length;
     for (i=0;i<psDst->length;i++)
@@ -2325,9 +2094,10 @@
   }
 }
-Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam)
+
+Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam, UInt compIdx)
 {
   UInt uiSymbol;
-  Int iSymbol;
-  static Int iTypeLength[MAX_NUM_SAO_TYPE] = {
+  static Int iTypeLength[MAX_NUM_SAO_TYPE] =
+  {
     SAO_EO_LEN,
     SAO_EO_LEN,
@@ -2337,27 +2107,54 @@
   }; 
 
-  parseSaoTypeIdx(uiSymbol);
+  if (compIdx==2)
+  {
+    uiSymbol = (UInt)( psSaoLcuParam->typeIdx + 1);
+  }
+  else
+  {
+    parseSaoTypeIdx(uiSymbol);
+  }
   psSaoLcuParam->typeIdx = (Int)uiSymbol - 1;
   if (uiSymbol)
   {
     psSaoLcuParam->length = iTypeLength[psSaoLcuParam->typeIdx];
+
+    Int bitDepth = compIdx ? g_bitDepthC : g_bitDepthY;
+    Int offsetTh = 1 << min(bitDepth - 5,5);
+
     if( psSaoLcuParam->typeIdx == SAO_BO )
     {
-      // Parse Left Band Index
-      parseSaoUflc( uiSymbol );
-      psSaoLcuParam->bandPosition = uiSymbol;
       for(Int i=0; i< psSaoLcuParam->length; i++)
       {
-        parseSaoSvlc(iSymbol);
-        psSaoLcuParam->offset[i] = iSymbol;
+        parseSaoMaxUvlc(uiSymbol, offsetTh -1 );
+        psSaoLcuParam->offset[i] = uiSymbol;
       }   
+      for(Int i=0; i< psSaoLcuParam->length; i++)
+      {
+        if (psSaoLcuParam->offset[i] != 0) 
+        {
+          m_pcTDecBinIf->decodeBinEP ( uiSymbol);
+          if (uiSymbol)
+          {
+            psSaoLcuParam->offset[i] = -psSaoLcuParam->offset[i] ;
+          }
+        }
+      }
+      parseSaoUflc(5, uiSymbol );
+      psSaoLcuParam->subTypeIdx = uiSymbol;
     }
     else if( psSaoLcuParam->typeIdx < 4 )
     {
-      parseSaoUvlc(uiSymbol); psSaoLcuParam->offset[0] = uiSymbol;
-      parseSaoUvlc(uiSymbol); psSaoLcuParam->offset[1] = uiSymbol;
-      parseSaoUvlc(uiSymbol); psSaoLcuParam->offset[2] = -(Int)uiSymbol;
-      parseSaoUvlc(uiSymbol); psSaoLcuParam->offset[3] = -(Int)uiSymbol;
-    }
+      parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[0] = uiSymbol;
+      parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[1] = uiSymbol;
+      parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[2] = -(Int)uiSymbol;
+      parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[3] = -(Int)uiSymbol;
+     if (compIdx != 2)
+     {
+       parseSaoUflc(2, uiSymbol );
+       psSaoLcuParam->subTypeIdx = uiSymbol;
+       psSaoLcuParam->typeIdx += psSaoLcuParam->subTypeIdx;
+     }
+   }
   }
   else
@@ -2367,5 +2164,5 @@
 }
 
-Void TDecSbac::parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Bool bLFCrossSliceBoundaryFlag)
+Void TDecSbac::parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp)
 {
   Int iAddr = pcCU->getAddr();
@@ -2375,5 +2172,5 @@
     pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag    = 0;
     pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag  = 0;
-    pSaoParam->saoLcuParam[iCompIdx][iAddr].bandPosition   = 0;
+    pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx     = 0;
     pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx        = -1;
     pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[0]     = 0;
@@ -2382,9 +2179,29 @@
     pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[3]     = 0;
 
-    if (pSaoParam->bSaoFlag[iCompIdx])
-    {
-      if (rx>0 && iCUAddrInSlice!=0)
-      {
-        parseSaoMergeLeft(uiSymbol,iCompIdx); pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = (Int)uiSymbol;
+  }
+ if (pSaoParam->bSaoFlag[0] || pSaoParam->bSaoFlag[1] )
+  {
+    if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
+    {
+      parseSaoMerge(uiSymbol); 
+      pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag = (Bool)uiSymbol;  
+    }
+    if (pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag==0)
+    {
+      if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
+      {
+        parseSaoMerge(uiSymbol);
+        pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag = (Bool)uiSymbol;
+      }
+    }
+  }
+
+  for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
+  {
+    if ((iCompIdx == 0  && pSaoParam->bSaoFlag[0]) || (iCompIdx > 0  && pSaoParam->bSaoFlag[1]) )
+    {
+      if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
+      {
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag;
       }
       else
@@ -2395,7 +2212,7 @@
       if (pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag==0)
       {
-        if ((ry > 0) && (iCUAddrUpInSlice>0||bLFCrossSliceBoundaryFlag))
+        if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
         {
-          parseSaoMergeUp(uiSymbol);  pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = uiSymbol;
+          pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag;
         }
         else
@@ -2405,5 +2222,6 @@
         if (!pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag)
         {
-          parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]));
+          pSaoParam->saoLcuParam[2][iAddr].typeIdx = pSaoParam->saoLcuParam[1][iAddr].typeIdx;
+          parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]), iCompIdx);
         }
         else
@@ -2420,9 +2238,9 @@
     {
       pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx = -1;
-      pSaoParam->saoLcuParam[iCompIdx][iAddr].bandPosition = 0;
-    }
-  }
-}
-#endif
+      pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx = 0;
+    }
+  }
+}
+
 /**
  - Initialize our contexts from the nominated source.
